#include <antiglut.h>
#include <stdio.h>
#include <assert.h>
#include <agu.h>
#include <math.h>
#include <../src/rg.c>

#define NUMPTS	10000
vec3_t pts[NUMPTS];
static ran_state_t state;

static void setup_scene()
{
	int i;
	vec3_t v;
	vec3Set(agm.mins,-1,-1,-1);
	vec3Set(agm.maxs,1,1,1);
	agm.ext_scale = 3;
	agm.draw_minor_grid = true;
	agm.draw_major_grid = true;
	agm.draw_tripod = true;
	agm.draw_bbox = true;
	agm.smooth_lines = true;
	agm.smooth_tripod = true;
	ranInitState(&state,1);
	for(i = 0;i < NUMPTS;i++)
	{
		ranNextVec3Range(&state,v,-1,1);
		ranDirection(&state,pts[i]);
		vec3Scale(pts[i],pts[i],5);
	}
}

vboolean draw_main(void)
{
	int i;
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	glEnable(GL_LINE_SMOOTH);
	glEnable(GL_POINT_SMOOTH);
	glPointSize(2);
	glColor4f(0, 0, 0, 0.7f);
	glBegin(GL_POINTS);
	for(i = 0;i < NUMPTS;i++)
		glVertex3fv(pts[i]);
	glEnd();
	return true;
}
	
int main()
{
	assert(sizeof(GLfloat) == sizeof(vec_t));
	agWindowConfig("Proper spherical distribution",
		768, 768, GL_FALSE);
	if(!agInit(AG_REQUIRED_1_1,GL_FALSE,GL_FALSE,GL_FALSE))
		return -1;
	setup_scene();
	glClearColor(1,1,1,0.5f);
	aguMainLoop(draw_main, NULL);
	agShutdown();
	return 0;
}
